
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>通过影响函数来理解黑盒预测---论文阅读报告 / 憋错料</title>

    <meta name="description" content="通过影响函数来理解黑盒预测---论文阅读报告 组员:曾文丽.倪元元.杨顼 时间:2020/4/15 1.背景 机器学习系统需要对自己所做的行为进行解释,然而在许多领域中表现最好的模型却是黑盒模型,它的重点在于了解固定模型如何导致特定预测,本文中主要是通过学习算法返回训练数据,最终得到模型参数,而在这儿需要对训练点进行考虑,所以使用了影响函数来对最小训练点进行提取,查看模型参数的变化,评估各种训练的干扰效果. 2.论文简介 论文主要是想通过学习算法跟踪模型的预测并返回训练数据来训练样本对决策的影响,找出某个决策影响最大的训练样本,大体上是通过">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">通过影响函数来理解黑盒预测---论文阅读报告</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>组员：曾文丽、倪元元、杨顼</p>
<p>时间：2020/4/15</p>
<h1>1.背景</h1>
<p>机器学习系统需要对自己所做的行为进行解释，然而在许多领域中表现最好的模型却是黑盒模型，它的重点在于了解固定模型如何导致特定预测，本文中主要是通过学习算法返回训练数据，最终得到模型参数，而在这儿需要对训练点进行考虑，所以使用了影响函数来对最小训练点进行提取，查看模型参数的变化，评估各种训练的干扰效果。</p>
<h1>2.论文简介</h1>
<p>论文主要是想通过学习算法跟踪模型的预测并返回训练数据来训练样本对决策的影响，找出某个决策影响最大的训练样本，大体上是通过oracle访问渐变和Hessian矢量产品来开发，提出高效的近似算法，作者最终通过实验证明，即使在理论失效的非对流和不可微模型上，对影响函数的逼近任然提供有价值的信息，这些函数对于多个目的都很有用，比如：理解模型行为、调试模型、检测数据测定器、以及创造可视可识别的训练集攻击。</p>
<h1>3.方法简介</h1>
<p>影响函数在统计学上有着丰富的历史，但是在机器学习中还是没有得到很广泛的应用，它是通过训练数据的镜头捕捉来研究模型的核心思想。</p>
<p>3.1 Upweighting a training point</p>
<p>为了了解训练点对模型的预测影响，通过反复事实来确定目标，然而，每个移除的z重新训练模型是非常缓慢的，所以它的设计思想是当计算z有参数变化时，给出新的参数</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAyMDA0LzIwMjAwNDE1MTM0MzI1OTUzMDk4LnBuZw==.jpg" /></p>
<p>利用1982年的一个经典结果</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAyMDA0LzIwMjAwNDE1MTM0MzI2MjUyOTE0LnBuZw==.jpg" /></p>
<p>在 附近形成了经验的二次近似，并采取了牛顿步骤，由于增加和去掉权重是一样的，所以在这儿采用的是去掉z来引起参数变化，不需要去训练新模型，通过测试样本上的loss变化来估计新参数</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAyMDA0LzIwMjAwNDE1MTM0MzI2MzEzNDYzLnBuZw==.jpg" /></p>
<p>3.2 perturbing a training input</p>
<p>通过修改样本来判断模型预测的改变，在这儿它给原来的x加上了一个小量</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAyMDA0LzIwMjAwNDE1MTM0MzI2MzcyMDU5LnBuZw==.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAyMDA0LzIwMjAwNDE1MTM0MzI2NDIzODE5LnBuZw==.jpg" /></p>
<p>扰动后将经验风险最小化，将质量从z移动到 <img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAyMDA0LzIwMjAwNDE1MTM0MzI2NDkwMjI4LnBuZw==.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAyMDA0LzIwMjAwNDE1MTM0MzI2NTQwMDM1LnBuZw==.jpg" />所产生的净参数。</p>
<p>对（1）的模拟计算得出：<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAyMDA0LzIwMjAwNDE1MTM0MzI2NTg4ODY1LnBuZw==.jpg" /></p>
<p>影响函数适用于微小扰动，并且，它的近似值适用于任意 ，当 很小时，可以进一步近似（3）得到：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAyMDA0LzIwMjAwNDE1MTM0MzI2Njg1NTQ4LnBuZw==.jpg" /></p>
<p>最终得到：<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAyMDA0LzIwMjAwNDE1MTM0MzI2Nzg4MDkxLnBuZw==.jpg" /></p>
<p>最终得到扰动对某个预测样本上loss的影响</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAyMDA0LzIwMjAwNDE1MTM0MzI2ODQxODA0LnBuZw==.jpg" /></p>
<p>3.3 Relation to Euclidean distance</p>
<p>这儿作者给了一个具体的例子，使用logistic回归来区分1和7，选择任意测试点z，绿点是与测试图像7相同，红点是与1相同，在这儿，作者给出了训练损失较大的带你，揭示了异常值可以支配的模型参数，然后，又实用加权方差矩阵测量了去除z的其他训练点的阻力，如果只想变化很小的方向，那么它的影响将会更大，因为向那个方向移动不会明显增加他的训练点损失，这便意味着影响函数比近邻更准确的捕捉模型训练的效果。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAyMDA0LzIwMjAwNDE1MTM0MzI2ODkzNTY0LnBuZw==.jpg" /></p>
<h1>4. 影响函数的用例</h1>
<p>在模型参数使得经验风险最小化，以及经验风险两次可微且严格凸的假设下，影响函数是一种渐进逼近，作者根据经验证明，影响函数是精确的近似值，即使违反了一些假设，但是也能够提供有用的信息。</p>
<p>4.1理解模型行为</p>
<p>通过对给定预测&ldquo;负责&rdquo;的训练点，影响函数揭示了模型如何依赖于训练数据并从中推断，作者为我们展示了两个实现方式不同的模型可以做出相同的正确预测，这儿作者对狗和鱼两类分别抽取了900个样本作为数据集，对比了Inception v3和SVM with RBF Kernel两个模型，展示了训练样本。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAyMDA0LzIwMjAwNDE1MTM0MzI2OTc0NjIyLnBuZw==.jpg" /></p>
<p>4.2生成对抗性训练样本</p>
<p>作者展示了对少数点有很大影响的模型可能容易受到训练输入扰动的影响，然后导致安全风险，最初，该模型对591/600个测试图像进行了正确分类。对于这591个测试图像中的每一个，作者分别考虑，试图在1800个总的训练图像中找到一个视觉上不可区分的干扰，这将反映模型的预测。该模型能够在591张测试图像中的335张（57%）上做到这一点。通过对每个测试图像扰动2个训练图像，该模型可以对591个测试图像中的77%进行预测；如果对10个训练图像进行扰动，该模型可以对591个测试图像中的1个进行预测。以上结果是分别攻击每个测试图像的结果，即使用不同的训练集攻击每个测试图像。作者还试图通过增加行程长度同时攻击多个测试，发现单训练图像扰动也会同时影响多个测试预测。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAyMDA0LzIwMjAwNDE1MTM0MzI4MTUxNDI1LnBuZw==.jpg" /></p>
<p>这种攻击在数学上等同于Biggio等人研究的基于梯度的训练集攻击，在两个类别的任务中构造了一个数据集，但必须用一种明显的可分辨的方式来区分训练点才能够有作业，loss为模型开发人员提供了一种量化模型对训练集攻击的脆弱程度方法。</p>
<h1>总结</h1>
<p>本篇论文作者讨论了各种应用，从创建训练集攻击到调试模型和数据集。每个应用程序的底层都有一个通用工具，影响函数，它是一个简单地思想，它通过查看模型行为是如何从其中训练数据中派生出，来更好的理解模型行为。在这儿，它的核心是影响函数测量局部变化的影响，它需要去解决影响函数依赖于变化不太大的模型，高性能、复杂的黑盒模型变得越来越重要，还需要从训练数据的角度对模型的开发、理解和诊断机器学习等方面进行研究。</p>
<h1>参考文献</h1>
<p>[1] https://zhuanlan.zhihu.com/p/38568075</p>
<p>[2] <a href="https://zhuanlan.zhihu.com/p/113511409" rel="external nofollow noreferrer">https://zhuanlan.zhihu.com/p/113511409</a></p>

<p>原文地址：https://www.cnblogs.com/zengwenli/p/12704659.html</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-06 15:46:59 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/oracle/" title="oracle">oracle</a>, <a href="https://www.biecuoliao.com/tag/%e5%b9%b6%e4%b8%94/" title="并且">并且</a>, <a href="https://www.biecuoliao.com/tag/%e4%bf%a1%e6%81%af/" title="信息">信息</a>, <a href="https://www.biecuoliao.com/tag/size/" title="size">size</a>, <a href="https://www.biecuoliao.com/tag/%e7%a7%bb%e5%8a%a8/" title="移动">移动</a>, <a href="https://www.biecuoliao.com/tag/%e8%bf%99%e4%b8%80/" title="这一">这一</a>, <a href="https://www.biecuoliao.com/tag/%e6%b8%90%e8%bf%9b/" title="渐进">渐进</a>, <a href="https://www.biecuoliao.com/tag/%e5%9b%be%e5%83%8f/" title="图像">图像</a>, <a href="https://www.biecuoliao.com/tag/%e5%8f%82%e8%80%83%e6%96%87%e7%8c%ae/" title="参考文献">参考文献</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>通过影响函数来理解黑盒预测---论文阅读报告的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MWeKr63.html" rel="bookmark">论文阅读记录&colon; Automatic Image Colorization sig16</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				sig论文阅读记录 Let there be Color!: Joint End-to-end Learning of Global and Local Image Priorsfor Automatic Image Colorization with Simultaneous Classification ( siggraph 2016 ) 论文简介 论文主页:http://hi.cs.waseda.ac.jp/~iizuka/projects/colorization/en/ 作者是来自Wa			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0k8Owz3.html" rel="bookmark">论文阅读与模型复现&mdash;&mdash;HAN</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				论文阅读论文链接:https://arxiv.org/pdf/1903.07293.pdf tensorflow版代码Github链接:https://github.com/Jhy1993/HAN 介绍视频:https://www.bilibili.com/video/av53418944/ 参考博客:https://blog.csdn.net/yyl424525/article/details/103804574 文中提出了一种新的基于注意力机制的异质图神经网络 Heterogeneous G			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4p1vvgM.html" rel="bookmark">YOLO 论文阅读</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				YOLO(You Only Look Once)是一个流行的目标检测方法,和Faster RCNN等state of the art方法比起来,主打检测速度快.截止到目前为止(2017年2月初),YOLO已经发布了两个版本,在下文中分别称为YOLO V1和YOLO V2.YOLO V2的代码目前作为Darknet的一部分开源在GitHub.在这篇博客中,记录了阅读YOLO两个版本论文中的重点内容,并着重总结V2版本的改进. [email protected]/04: YOLO v3已经发布!可以			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0lGx7WM.html" rel="bookmark">论文阅读方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				论文阅读方法 别先读摘要,从导言部分入手 找出大问题 这个领域正在设法解决什么问题? 以不超过5句话的篇幅总结背景 为解决这一&quot;大问题&quot;,这一领域做过什么努力?之前的工作有什么局限?在作者看来,下一步需要做什么?简洁地解释为什么要进行这项研究. 找出具体问题 作者在他们的研究中究竟想回答什么问题?把这些问题(不一定是一个)写下来.如果是那种研究一个或者多个零假设的研究,把零假设辨别出来. 弄清解决手段 为了回答这些具体的问题,作者要怎么做? 阅读方法部分 为每一个实验画出一个图表,画出			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0YY8jy0.html" rel="bookmark">Google File System 论文阅读笔记</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				核心目标:Google File System是一个面向密集应用的,可伸缩的大规模分布式文件系统.GFS运行在廉价的设备上,提供给了灾难冗余的能力,为大量客户机提供了高性能的服务. 1．一系列前提 GFS的系统构建针对其自身使用的特点在传统的分布式系统的基础上又进行了一些创新,基于的前提假设主要包括以下方面: 1.由于系统由廉价的商用机构成,组件失效被认为是一种常态,系统必须可以持续监控自身的状态. 2.系统存储以大文件为主,小文件也支持,但是没有进行特别的优化处理. 3.系统的工作负载主要包含			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4NGQVBM.html" rel="bookmark">深度学习论文阅读笔记--Deep Learning Face Representation from Predicting 10&comma;000 Classes</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				来自:CVPR 2014   作者:Yi Sun ,Xiaogang Wang,Xiaoao Tang 题目:Deep Learning Face Representation from Predicting 10,000 Classes 主要内容:通过深度学习来进行图像高级特征表示(DeepID),进而进行人脸的分类. 优点:在人脸验证上面做,可以很好的扩展到其他的应用,并且夸数据库有效性:在数据库中的类别越多时,其泛化能力越强,特征比较少,不像其他特征好几K甚至上M,好的泛化能力+不过拟合于			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MBzpYvM.html" rel="bookmark">论文阅读--Scalable Object Detection using Deep Neural Networks</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Scalable Object Detection using Deep Neural Networks 作者: Dumitru Erhan, Christian Szegedy, Alexander Toshev, and Dragomir Anguelov 引用: Erhan, Dumitru, et al. &quot;Scalable object detection using deep neural networks.&quot; Proceedings of the IEEE Confere			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/47BvA63.html" rel="bookmark">AD预测论文研读系列1</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				A Deep Learning Model to Predict a Diagnosis of Alzheimer Disease by Using 18F-FDG PET of the Brain 原文链接 提要 目的 开发并验证一种深度学习算法,该算法可以基于脑部18F FDG PET来预测AD.轻度认知障碍或者二者均不是的诊断结果,并将其性能与放射学阅读器的性能进行比较 材料和方法 来自ADNI的18F-FDG PET脑图(含2109张图片,包括1002个病人)用于训练.验证,40张来自4			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0lxnxb0.html" rel="bookmark">论文阅读 &vert; FCOS&colon; Fully Convolutional One-Stage Object Detection</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				论文阅读——FCOS: Fully Convolutional One-Stage Object Detection 概述 目前anchor-free大热,从DenseBoxes到CornerNet.ExtremeNet,以及最近的FSAF.FoveaBox,避免了复杂的超参数设计,而且具有很好的检测效果.本文作者提出了一种全卷积的单阶段目标检测算法,类似于语义分割的做法使用像素级预测.该检测框架简单有效,而且可以方便地用于其他任务. 简介 再啰嗦一下基于anchor的检测算法的缺陷: 1.检测			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/BMzBQkM.html" rel="bookmark" class="title">SharePoint Workflow架构（一）SharePoint 和Workflow Runtime的结合</a>
					<div>
						[译者按]Andy Li这篇文章,是我看过的最好的,最透彻的关于SharePoint Workflow架构的文章.通过阅读他的文章,我才清楚的了解了SharePoint Workflow的运作机制,并 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/v0k2zLM.html" rel="bookmark" class="title">Visual Studio 2017 的 JavaScript 调试功能的关闭</a>
					<div>
						关闭方法其实很简单,Options =&gt; Debugging =&gt; General =&gt; Enable JavaScript debugging for ASP.NET (Chrom ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/n0lLqp0.html" rel="bookmark" class="title">微信公共平台C&num;源代码</a>
					<div>
						&lt;%@ Page Language=&quot;C#&quot; AutoEventWireup=&quot;true&quot; CodeBehind=&quot;Default.aspx.c ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AP5jd3.html" rel="bookmark" class="title">朋友圈常见单页面触屏滑动上下翻屏功能jQuery实现</a>
					<div>
						JS代码(jquery.showup.js): /** * @Creator: Nelson Kuang/Fast Mover * @showup 翻页插件:实现原理,用margin-top来控制页面 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wrgxZ0.html" rel="bookmark" class="title">UIScrollView无法滚动</a>
					<div>
						•如果UIScrollView无法滚动,可能是以下原因: Ø没有设置contentSize ØscrollEnabled = NO Ø没有接收到触摸事件:userInteractionEnabled  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MywJmL3.html" rel="bookmark" class="title">win8 sqlserver2005  安装</a>
					<div>
						操作过程详见老一辈文档:http://blog.csdn.net/chinmusam/article/details/8908422安装中 安装到SqlServer服务的时候提示启动服务失败,需要下载 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QWJV20.html" rel="bookmark" class="title">MySQL1-基础知识点</a>
					<div>
						目录 零.MySQL安装与配置 一.基本概念 二.基本语法 三.常用指令 四.四种SQL语句 零.MySQL安装与配置 http://www.cnblogs.com/hikarusun/archive ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPWYjz4.html" rel="bookmark" class="title">struts2入门之action获取表单提交数据</a>
					<div>
						action获取表单提交数据,有三种方式: 1.根据ActionContext对象获取: 2.利用ServletActionContext类获取表单数据:(其实就是可以获取HttpServletReq ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3v5pLk0.html" rel="bookmark" class="title">OC之字符串 NSString与NSMutableString</a>
					<div>
						一.NSString 不可变字符串的操作1)将字符串常量对象直接赋值给字符串引用 NSString *[email protected]&quot;hello&quot;; 字符串对象的输出格式:NS ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wWloR3.html" rel="bookmark" class="title">IOS常用的第三方开发库</a>
					<div>
						开发几个常用的开源类库及下载地址: 1.json json编码解码2.GTMBase64 base64编码解码3.TouchXML xml解析4.SFHFKeychainUtils 安全保存用户密码到 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nPqQV4.html" rel="bookmark" class="title">vsftp 虚拟用户</a>
					<div>
						首先安装vsftp db-4wiki mkdir -p /opt/ftp 创建用户 sudo useradd virtual -d /opt/ftp -s /bin/false sudo chown  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35rVoK4.html" rel="bookmark" class="title">VMware 12Pro 安装MACOS 10&period;10</a>
					<div>
						? 前言 最近帮人MacBook PRO重新安装了下10.10,在加上用了IP6,对苹果系统很有好感,所以想自己装个mac系统玩一下.虽然有了surface pro3 但是看了时间久了厌了,好想买个M ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qRQap4.html" rel="bookmark" class="title">Ntop监控网络流量</a>
					<div>
						运用Ntop监控网络流量 ____ 网络流量反映了网络的运行状态,是判别网络运行是否正常的关键数据,在实际的网络中,如果对网络流量控制得不好或发生网络拥塞,将会导致网络吞吐量下降. 网络性能降低.通过 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgEwqN3.html" rel="bookmark" class="title">笔记函数 - Ring0 Sleep&lpar;&rpar;</a>
					<div>
						1 #define DELAY_ONE_MICROSECOND (-10) 2 #define DELAY_ONE_MILLISEND (DELAY_ONE_MICROSECOND*1000) 3 v ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MEWxVD3.html" rel="bookmark" class="title">样式重置</a>
					<div>
						嗯,浏览器一般会设置,默认样式,对于,我们来说,这样很不方便,所以就有了样式重置. 接下来我推荐两个样式重置的  小东西 resert 我这里附上当前最新的版本,如有需要可以直接去,resert.co ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pkVZx3.html" rel="bookmark" class="title">find查找命令的各种使用方法</a>
					<div>
						find是文件查找工具,实时查找,速度慢,精确匹配 find命令基本使用格式 find [options] [查找路径] [查找条件] [处理动作] 查找路径:默认为当前目录 查找条件:默认为查找指定 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPXW2BM.html" rel="bookmark" class="title">app游戏测试在外网搭建账号及sdk</a>
					<div>
						app游戏测试在外网搭建账号,如下(这部分是我写的) 手机游戏测试中,临时验证一些问题,无法搭建数据或者搭建成本过大会产用这个办法 1)外网玩家 都会有1个区服 和roleid,先需要知道区服和rol ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dEQee3.html" rel="bookmark" class="title">查看表用量</a>
					<div>
						通过游标和SP_SPACEUSED来查看当前库所有表数据行.已分配空间总量.数据使用总量.索引使用总量.已分配但未使用总量 1 if OBJECT_ID ('tempdb..#temp') is no ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MENnQK0.html" rel="bookmark" class="title">通过属性集名称获取属性集id</a>
					<div>
						Mage::getModel('eav/entity_attribute_set')-&gt;load('属性集名称', 'attribute_set_name')-&gt;getAttributeS ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyNJGm0.html" rel="bookmark" class="title">ASP&period;NET-【Excel】-将Excel中的数据批量加载到SQLserver数据库</a>
					<div>
						用到了一个SqlBulkCopy的类 核心代码分析 代码我还没有测试过 string excelConnectionString = string.Format(&quot;Provider=Micr ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.028 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
